customer = new.tableRef("customer", "PostgreSQL", "postgre.config", "tpch")
orders = new.tableRef("orders", "PostgreSQL", "postgre.config", "tpch")
lineitem = new.tableRef("lineitem", "PostgreSQL", "postgre.config", "tpch")
supplier = new.tableRef("supplier", "PostgreSQL", "postgre.config", "tpch")
nation = new.tableRef("nation", "PostgreSQL", "postgre.config", "tpch")
region = new.tableRef("region", "PostgreSQL", "postgre.config", "tpch")
q =
order(function(x) c(x$revenue), function(x) c(FALSE),
group(function(x) c(x$n_name),
select(function(x){
  y = new.env()
  y$n_name = x$n_name
  y$revenue = sum(x$l_extendedprice * (1 - x$l_discount))
  y
},
where(function(x) x$r_name == "ASIA" && x$o_orderdate >= date("1994-01-01")
       && x$o_orderdate < date("1994-01-01") + interval(1, "year"),
join(from(customer),
join(from(orders),
join(from(lineitem),
join(from(supplier),
join(from(nation),
     from(region),
     function(x, y) x$n_regionkey == y$r_regionkey),
     function(x, y) x$s_nationkey == y$n_nationkey),
     function(x, y) x$l_suppkey == y$s_suppkey),
     function(x, y) x$o_orderkey == y$l_orderkey),
     function(x, y) x$c_custkey == y$o_custkey && x$c_nationkey == y$s_nationkey)))))
print(query.force(q))
